!******************************************************************************!
!*                                  METATHUNK.CLW                             *!
!*                                                                            *!
!*      Copyright (C) 1995 P.S. Wilson & Associates, all rights reserved.     *!
!*                                                                            *!
!*  Meta File Driver: Thunking module.                                        *!
!*                                                                            *!
!*  Sean Wilson, 29 March 1996                                                *!
!******************************************************************************!
MetaThunk       PROGRAM

                INCLUDE('Windows.INC')

                MAP
                  DrvPipe(SIGNED, POINTER, POINTER), LONG, TYPE
                  CallPipe(*DrvPipe, SIGNED, POINTER, POINTER), LONG
                END
  CODE

!*** CALLPIPE *****************************************************************
!*
!*  Synopsis:
!*      CallPipe(*DrvPipe Pipe, SIGNED Op, POINTER Fcb, POINTER Args)
!*
!*  Description:
!*      CallPipe() is a 'thunk', which is a function that provides parameter
!*      translation for an API.  CallPipe() is called from META() as a
!*      function which accepts a the address of a File Driver's pipe function
!*      as it's first parameter.  In this module, the first parameter is
!*      prototypes as a *DrvPipe.  This allows us to supply an address of an
!*      external, unnamed procedure to CallPipe which can invoke it as a
!*      DrvPipe type function.  The whole procedure provides a simple means
!*      to overcome a slight limitation of the Clarion language by defeating
!*      it's typing mechanism.
!*
!*  NOTE:
!*      This function will cause a linker warning: 'type inconsistency' this
!*      unavoidable and harmless in this case, though usually very serious.

CallPipe        FUNCTION(Pipe, Op, Fcb, Args)
  CODE
  RETURN Pipe(Op, Fcb, Args)
