MetaTst     PROGRAM

            INCLUDE('Meta.INC')

            MAP
              ExitProc()
              ChkCreate(FILE, STRING)
              ChkOpen(FILE)
              ChkAdd(FILE)
              ChkSet(FILE)
              ChkNext(FILE)
              ChkClose(FILE)
              ErrChk(STRING)
            END

Driver      STRING(256)

F1          FILE,DRIVER('Meta', Driver),CREATE
KP            KEY(F1:Str1)
              RECORD
Str1            STRING(10)
              END
            END

  CODE
  SHUTDOWN(ExitProc)
  ChkCreate(F1, 'CWCLA32.DLL')
  ChkCreate(F1, 'CWTPS32.DLL')

  MESSAGE('Start')

  !*** At this point Driver contains /DRIVER=CWTPS32.DLL
  ChkOpen(F1)

  LOOP i# = 10 TO 1 BY -1
    F1:Str1 = FORMAT(i#, @N04)
    ChkAdd(F1)
  END

  ChkSet(F1)
  i# = 10
  LOOP
    ChkNext(F1)
    IF ERRORCODE() THEN
      BREAK
    END
    IF CLIP(F1:Str1) <> FORMAT(i#, @N04) THEN
      MESSAGE('Bad data')
      BREAK
    END
    i# -= 1
  END

  ChkClose(F1)
  MESSAGE('Done')

ExitProc    PROCEDURE
  CODE
  MetaShutdown()

ChkOpen     PROCEDURE(f)
  CODE
  OPEN(f)
  ErrChk('OPEN(f)')

ChkAdd      PROCEDURE(f)
  CODE
  ADD(f)
  ErrChk('ADD(f)')

ChkSet      PROCEDURE(f)
  CODE
  SET(f)
  ErrChk('SET(f)')

ChkNext     PROCEDURE(f)
  CODE
  NEXT(f)
  IF ERRORCODE() <> 33 THEN
    ErrChk('NEXT(f)')
  END

ChkClose    PROCEDURE(f)
  CODE
  CLOSE(f)
  ErrChk('CLOSE(f)')

ChkCreate   PROCEDURE(f, d)
  CODE
  Driver = '/DRIVER=' & d
  CREATE(f)
  ErrChk('CREATE(f, ' & CLIP(d) & ')')


ErrChk  PROCEDURE(f)
Str       CSTRING(256)
Err       LONG
  CODE
  Err = ERRORCODE()
  IF Err THEN
    IF (Err = 90) AND FILEERRORCODE() THEN
      Str = CLIP(FILEERRORCODE())
      Str = 'Driver Error (' & CLIP(Str) & '): ' & CLIP(FILEERROR())
    ELSE
      Str = 'Clarion Error: (' & ERRORCODE() & '):' & ERROR()
    END
    MESSAGE(Str, f)
  END
