!******************************************************************************
!*                                  WINDOWS.INC                               *
!*                                                                            *
!*  Windows API definitions for Clarion for Windows                           *
!*                                                                            *
!*  Copyright (c) 1992-1995, Microsoft Corp. All rights reserved.             *
!*                                                                            *
!*  Transcribed by Sean Wilson                                                *
!******************************************************************************

!*** System dependent types ***************************************************
COMPILE('End32',_WIN32)
  INCLUDE('Win32.INC', 'SystemTypes')
!End32
OMIT('End16',_WIN32)
  INCLUDE('Win16.INC', 'SystemTypes')
!End16

!*** System independent types *************************************************
POINTER                     EQUATE(ULONG)
CHAR                        EQUATE(BYTE)
HWND                        EQUATE(HANDLE)
DWORD                       EQUATE(ULONG)
HINSTANCE                   EQUATE(HANDLE)
HMODULE                     EQUATE(HANDLE)
LPCSTR                      EQUATE(POINTER)
LPSTR                       EQUATE(POINTER)
WORD                        EQUATE(USHORT)
WPARAM                      EQUATE(UINT)
LPARAM                      EQUATE(LONG)
LRESULT                     EQUATE(LONG)
WNDPROC                     EQUATE(POINTER)
FARPROC                     EQUATE(ULONG)


!*** Winuser

NMHDR                       GROUP, TYPE
hwndFrom                      HWND
idFrom                        UINT
code                          UINT
                            END

LPNMHDR                     EQUATE(POINTER)

WM_DESTROY                  EQUATE(0002h)
WM_INITDIALOG               EQUATE(0110h)
WM_COMMAND                  EQUATE(0111h)
WM_USER                     EQUATE(0400h)

IDOK                        EQUATE(1)
IDCANCEL                    EQUATE(2)

!*** WINGDI

!*** Logical Font
LF_FACESIZE                 EQUATE(32)

LOGFONT                     GROUP, TYPE
lfHeight                      LONG
lfWidth                       LONG
lfEscapement                  LONG
lfOrientation                 LONG
lfWeight                      LONG
lfItalic                      BYTE
lfUnderline                   BYTE
lfStrikeOut                   BYTE
lfCharSet                     BYTE
lfOutPrecision                BYTE
lfClipPrecision               BYTE
lfQuality                     BYTE
lfPitchAndFamily              BYTE
lfFaceName                    CSTRING(LF_FACESIZE-1)
                            END

LPLOGFONT                   EQUATE(POINTER)


CCHDEVICENAME               EQUATE(32)
CCHFORMNAME                 EQUATE(32)

DEVMODE                     GROUP, TYPE
dmDeviceName                  CSTRING(CCHDEVICENAME-1)
dmSpecVersion                 WORD
dmDriverVersion               WORD
dmSize                        WORD
dmDriverExtra                 WORD
dmFields                      DWORD
dmOrientation                 SHORT
dmPaperSize                   SHORT
dmPaperLength                 SHORT
dmPaperWidth                  SHORT
dmScale                       SHORT
dmCopies                      SHORT
dmDefaultSource               SHORT
dmPrintQuality                SHORT
dmColor                       SHORT
dmDuplex                      SHORT
dmYResolution                 SHORT
dmTTOption                    SHORT
dmCollate                     SHORT
dmFormName                    CSTRING(CCHFORMNAME-1)
dmLogPixels                   WORD
dmBitsPerPel                  DWORD
dmPelsWidth                   DWORD
dmPelsHeight                  DWORD
dmDisplayFlags                DWORD
dmDisplayFrequency            DWORD
dmICMMethod                   DWORD
dmICMIntent                   DWORD
dmMediaType                   DWORD
dmDitherType                  DWORD
dmReserved1                   DWORD
dmReserved2                   DWORD
                            END

LPDEVMODE                   EQUATE(POINTER)


!*** WTYPES
HDC                         EQUATE(POINTER)
HGLOBAL                     EQUATE(POINTER)
COLORREF                    EQUATE(DWORD)
LPCOLORREF                  EQUATE(POINTER)
LPVOID                      EQUATE(POINTER)

POINT                       GROUP, TYPE
x                             LONG
y                             LONG
                            END

LPPOINT                     EQUATE(POINTER)

RECT                        GROUP, TYPE
left                          LONG
top                           LONG
right                         LONG
bottom                        LONG
                            END

LPRECT                      EQUATE(POINTER)

!*** Winbase
GMEM_FIXED                  EQUATE(0000h)
GMEM_MOVEABLE               EQUATE(0002h)
GMEM_NOCOMPACT              EQUATE(0010h)
GMEM_NODISCARD              EQUATE(0020h)
GMEM_ZEROINIT               EQUATE(0040h)
GMEM_MODIFY                 EQUATE(0080h)
GMEM_DISCARDABLE            EQUATE(0100h)
GMEM_NOT_BANKED             EQUATE(1000h)
GMEM_SHARE                  EQUATE(2000h)
GMEM_DDESHARE               EQUATE(2000h)
GMEM_NOTIFY                 EQUATE(4000h)
GMEM_LOWER                  EQUATE(GMEM_NOT_BANKED)
GMEM_VALID_FLAGS            EQUATE(7F72h)
GMEM_INVALID_HANDLE         EQUATE(8000h)

GHND                        EQUATE(GMEM_MOVEABLE+GMEM_ZEROINIT)
GPTR                        EQUATE(GMEM_FIXED+GMEM_ZEROINIT)

!*** Windows Error Codes ******************************************************
HINSTANCE_ERROR             EQUATE(32)

!*** System dependent prototypes **********************************************
COMPILE('End32',_WIN32)
  INCLUDE('Win32.INC', 'SystemPrototypes')
!End32
OMIT('End16',_WIN32)
  INCLUDE('Win16.INC', 'SystemPrototypes')
!End16

!*** System independent prototypes ********************************************
  MAP
    MODULE('Windows')
      GlobalAlloc(UINT, DWORD), HGLOBAL, RAW, PASCAL, NAME('GlobalAlloc')
      GlobalLock(HGLOBAL), LPVOID, RAW, PASCAL, NAME('GlobalLock')
      GlobalUnlock(HGLOBAL), BOOL, RAW, PASCAL, NAME('GlobalUnlock')
    END
  END

